#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include "md5.h"
#include "csik.h"

char md[20];
char buf[17000];

int i;
int fd;
int blsz;
char dummy;
int cs=0;
long long int length;
long long int sofar=0;
struct stat fdstat;
int end=0;

int main (int argc, char *argv[])
{
	if (argc != 3 && argc != 5) {
		fprintf(stderr, "Usage: md5blocks blocksize filename [info length]\n");
		exit(1);
	}
	cs=(argc==5);
	if (argv[2][0]=='-' && argv[2][1]==0) {
		if (cs) {
			fprintf(stderr, "- and info don't work together\n");
			exit(1);
		}
		fd=0;
	}
	else {
		fd=open(argv[2], O_RDONLY);
		if (fd==-1) {
			fprintf(stderr, "Cannot open file: %s\n", sys_errlist[errno]);
			exit(1);
		}
		if (cs) {
			i=sscanf(argv[4], "%lld%c", &length, &dummy);
			if (i!=1) {
				fprintf(stderr, "Invalid length.\n");
				exit(1);
			}
		}
	}
	i=sscanf(argv[1], "%d%c", &blsz, &dummy);
	if (i!=1 || (blsz!=1024 && blsz!=2048 && blsz!=4096 && blsz!=8192 && blsz!=16384)) {
		fprintf(stderr, "Invalid block size. Valid sizes: 1024, 2048, 4096, 8192, 16384.\n");
		exit(1);
	}
	if (cs) csik(0, length, argv[3]);

	while ((i=read(fd, buf, blsz)) != 0 && (!cs || sofar < length)) {
		if (end) {
			fprintf(stderr, "Could not read %d bytes\n", blsz);
			exit(1);
		}
		if (i<0) {
			fprintf(stderr, "Read failed: %s\n", sys_errlist[errno]);
			exit(1);
		}
		if (i!=blsz) end=1;
		md5_buffer(buf, i, md);
		for (i=0; i<16; i++)
			printf("%02x", (unsigned char)md[i]);
		printf("\n");
		sofar++;
		if (cs) csik(sofar, length, argv[3]);
	}
	return 0;
}
