#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "md5.h"

FILE *a;
FILE *b;
int blsz;
char dummy;
char aa[200];
char bb[200];
char zz[200];
char zzc[20];
int al;
int bl;
int zl;
char zeros[17000];
int i;

int main (int argc, char *argv[])
{
	if (argc!=4) {
		fprintf(stderr, "Hasznlat: linecmp blocksize file1 file2\n"
		                "mnusz jel a stdin-t jelenti\n"
		                "Kir minden sorprra egy karaktert majd newline-t\n"
		                "0 ha azonos a kt sor\n"
		                "1 ha klnbznek\n"
		                "z ha klnbznek, de a file2-ben a csupa nulla md5sum-ja ll\n"
		                "EOF-nak file1-en legksbb akkor kell jnnie, mint file2-n\n");
		exit(1);
	}
	i=sscanf(argv[1], "%d%c", &blsz, &dummy);
	if (i!=1 || (blsz!=1024 && blsz!=2048 && blsz!=4096 && blsz!=8192 && blsz!=16384)) {
		fprintf(stderr, "Invalid block size. Valid sizes: 1024, 2048, 4096, 8192, 16384.\n");
		exit(1);
	}
	if (argv[2][0]=='-' && argv[2][1]==0) {
		a=stdin;
	}
	else {
		a=fopen(argv[2], "r");
		if (a==NULL) {
			fprintf(stderr, "linecmp: %s: %s\n", argv[2], sys_errlist[errno]);
			exit(1);
		}
	}
	if (argv[3][0]=='-' && argv[3][1]==0) {
		b=stdin;
	}
	else {
		b=fopen(argv[3], "r");
		if (b==NULL) {
			fprintf(stderr, "linecmp: %s: %s\n", argv[3], sys_errlist[errno]);
			exit(1);
		}
	}

	for (i=0; i<17000; i++) zeros[i]=0;
	md5_buffer(zeros, blsz, zzc);
	for (i=0; i<16; i++) sprintf(zz+2*i, "%02x", (unsigned char)(zzc[i]));
	zz[32]='\n';
	zz[zl=33]=0;

	while (1) {
		if (fgets(aa, 180, a)==NULL) exit(0);
		if (fgets(bb, 180, b)==NULL) {
			fprintf(stderr, "EOF on %s\n", argv[3]);
			exit(1);
		}
		al=strlen(aa);
		bl=strlen(bb);
		if (al==bl && !strncmp(aa, bb, al)) printf("0\n");
		else if (bl==zl && !strncmp(bb, zz, bl)) printf("z\n");
		else printf("1\n");
	}
}
