#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define BSIZE 1048576

char buf[BSIZE];
int zero;
int fd;
int i, j;
int r, w;

int main (int argc, const char *argv[])
{
	if (argc != 2) {
		fprintf(stderr, "Usage: slowcat filename\n");
	}
	if (!strcmp(argv[1], "/dev/zero")) zero=1;

	if (fcntl(1, F_SETFL, O_SYNC) < 0) {
		fprintf(stderr, "fcntl: %s\n", sys_errlist[errno]);
		exit(1);
	}
	nice(10);

	if (!zero) {
		if ((fd = open(argv[1], O_RDONLY)) < 0) {
			fprintf(stderr, "open: %s\n", sys_errlist[errno]);
			exit(1);
		}
	} else {
		for (i = 0; i < BSIZE; i++) buf[i] = 0;
	}

	j = 0;
	while (1) {
		if (!zero) {
			r = read(fd, buf, BSIZE);
			if (r < 0) {
				fprintf(stderr, "read: %s\n", sys_errlist[errno]);
				exit(1);
			}
			if (r == 0) return 0;
		} else {
			r = BSIZE;
		}
		i = 0;
		while (r > 0) {
			w = write(1, buf+i, r);
			if (w < 0) {
				if (errno == ENOSPC) return 0;
				fprintf(stderr, "write: %s\n", sys_errlist[errno]);
				exit(1);
			}
			r -= w;
			i += w;
		}
		usleep(5000);			/* 5ms / 1M sleep */
		if (j++ == 100) {
			j = 0;
			usleep(1000000);	/* 1s / 100M sleep */
		}
	}
}
